﻿using System;

namespace Ion.HabboHotel.Client
{
    /// <summary>
    /// Provides the opcodes (message IDs) that trigger actions in the client.
    /// </summary>
    public static class ResponseOpcodes
    {
        public const uint Hello = 0;
        public const uint SecretKey = 1;
        public const uint UserRights = 2;
        public const uint AuthenticationOK = 3;
        public const uint UserObject = 5;
        public const uint CreditBalance = 6;
        public const uint ScrSendUserInfo = 7;
        public const uint MessengerInit = 12;
        public const uint FriendListUpdate = 13;
        public const uint CloseConnection = 18;
        public const uint OpenConnection = 19;
        public const uint Chat = 24;
        public const uint Whisper = 25;
        public const uint Shout = 26;
        public const uint Users = 28;
        public const uint UserRemove = 29;
        public const uint HeightMap = 31;
        public const uint Objects = 32;
        public const uint GenericError = 33;
        public const uint UserUpdate = 34;
        public const uint UserBanned = 35;
        public const uint FlatAccessible = 41;
        public const uint YouAreController = 42;
        public const uint YouAreNotController = 43;
        public const uint NoSuchFlat = 44;
        public const uint Items = 45;
        public const uint RoomProperty = 46;
        public const uint YouAreOwner = 47;
        public const uint ItemDataUpdate = 48;
        public const uint Ping = 50;
        public const uint FlatCreated = 59;
        public const uint DoorOtherEndDeleted = 63;
        public const uint DoorNotInstalled = 64;
        public const uint PurchaseError = 65;
        public const uint PurchaseOK = 67;
        public const uint NotEnoughBalance = 68;
        public const uint RoomReady = 69;
        public const uint ItemAdd = 83;
        public const uint ItemRemove = 84;
        public const uint ItemUpdate = 85;
        public const uint ObjectDataUpdate = 88;
        public const uint DiceValue = 90;
        public const uint Doorbell = 91;
        public const uint ObjectAdd = 93;
        public const uint ObjectRemove = 94;
        public const uint ObjectUpdate = 95;
        public const uint FurniListInsert = 98;
        public const uint FurniListRemove = 99;
        public const uint FurniListUpdate = 101;
        public const uint TradingYouAreNotAllowed = 102;
        public const uint TradingOtherNotAllowed = 103;
        public const uint TradingOpen = 104;
        public const uint TradingAlreadyOpen = 105;
        public const uint TradingNotOpen = 106;
        public const uint TradingNoSuchItem = 107;
        public const uint TradingItemList = 108;
        public const uint TradingAccept = 109;
        public const uint TradingClose = 110;
        public const uint TradingConfirmation = 111;
        public const uint TradingCompleted = 112;
        public const uint CatalogIndex = 126;
        public const uint CatalogPage = 127;
        public const uint PresentOpened = 129;
        public const uint FlatAccessDenied = 131;
        public const uint NewBuddyRequest = 132;
        public const uint NewConsole = 134;
        public const uint RoomInvite = 135;
        public const uint FurniList = 140;
        public const uint PostItPlaced = 145;
        public const uint Mod = 161;
        public const uint VoucherRedeemOk = 212;
        public const uint VoucherRedeemError = 213;
        public const uint HeightMapUpdate = 219;
        public const uint UserFlatCats = 221;
        public const uint FlatCat = 222;
        public const uint HabboUserBadges = 228;
        public const uint Badges = 229;
        public const uint SlideObjectBundle = 230;
        public const uint SessionParams = 257;
        public const uint MessengerError = 260;
        public const uint InstantMessageError = 261;
        public const uint RoomInviteError = 262;
        public const uint UserChange = 266;
        public const uint InitCrypto = 227;
        public const uint RoomForward = 286;
        public const uint DisconnectReason = 287;
        public const uint PurchaseNotAllowed = 296;
        public const uint ErrorReport = 299;
        public const uint HabboGroupBadges = 309;
        public const uint OneWayDoorStatus = 312;
        public const uint BuddyRequests = 314;
        public const uint AcceptBuddyResult = 315;
        public const uint RoomRating = 345;
        public const uint FollowFriendFailed = 349;
        public const uint UserTags = 350;
        public const uint UserTyping = 361;
        public const uint RoomDimmer = 365;
        public const uint CanCreateRoomEvent = 367;
        public const uint RoomEvent = 370;
        public const uint IgnoreResult = 419;
        public const uint IgnoredUsers = 420;
        public const uint HabboSearchResult = 435;
        public const uint Achievements = 436;
        public const uint HabboAchievementNotification = 437;
        public const uint HabboActivityPointNotification = 438;
        public const uint UniqueMachineID = 439;
        public const uint RespectNotification = 440;
        public const uint CatalogPublished = 441;
        public const uint NavigatorFrontPageResult = 450;
        public const uint GuestRoomSearchResult = 451;
        public const uint PopularRoomTagsResult = 452;
        public const uint OfficialRoomsResult = 453;
        public const uint GetGuestRoomResult = 454;
        public const uint NavigatorSettings = 455;
        public const uint RoomInfoUpdated = 456;
        public const uint RoomThumbnailUpdateResult = 457;
        public const uint Favourites = 458;
        public const uint FavouriteChanged = 459;
        public const uint AvatarEffects = 460;
        public const uint AvatarEffectAdded = 461;
        public const uint AvatarEffectActivated = 462;
        public const uint AvatarEffectExpired = 463;
        public const uint AvatarEffectSelected = 464;
        public const uint RoomSettingsData = 465;
        public const uint RoomSettingsError = 466;
        public const uint RoomSettingsSaved = 467;
        public const uint RoomSettingsSaveError = 468;
        public const uint FloorHeightMap = 470;
        public const uint RoomEntryInfo = 471;
        public const uint Dance = 480;
        public const uint Wave = 481;
        public const uint CarryObject = 482;
        public const uint AvatarEffect = 485;
        public const uint Sleep = 486;
        public const uint UseObject = 488;
        public const uint FlatControllerAdded = 510;
        public const uint FlatControllerRemoved = 511;
        public const uint CanCreateRoom = 512;
        public const uint PlaceObjectError = 516;
        public const uint InfoFeedEnable = 517;
    }
}